function isCreative(player) {
    try { return player.getGameMode() === "creative"; } 
    catch { /*console.warn(`[Function Error]: isCreative() was called on an entity that is not a player. Returned false.`);*/ return false; 
}

function applyDurabilityDamage(entity, itemStack, slot, damage) {
    if (isCreative(entity)) { return; }
    const unbreakingLevel = itemStack.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level ?? 0;
    const r = Math.floor(Math.random() * 10);
    if (!unbreakingLevel) durDmgCont(entity, itemStack, slot, damage);
    else if (unbreakingLevel === 1 && r > 2) durDmgCont(entity, itemStack, slot, damage);
    else if (unbreakingLevel === 2 && r > 4) durDmgCont(entity, itemStack, slot, damage);
    else if (unbreakingLevel === 3 && r > 5) durDmgCont(entity, itemStack, slot, damage);
}

function getItemType(itemStack) {
    if(itemStack === undefined) { return ""; }
    const arr1 = getItemName(itemStack).split("_");
    const arr2 = arr1[0].split(":");
    const arr = arr2.concat(arr1.splice(1));
    if(itemStack.hasTag("yes:two_worded_type")) { return `${arr[arr.length-2]}_${arr[arr.length-1]}`; }
    else { return arr[arr.length-1]; }
}

function getTagName(itemStack, namespace) {
    const type = itemStack.hasTag("minecraft:is_armor") ? getArmorType(itemStack) : getItemType(itemStack);
    if(namespace === undefined || namespace === "ability:") {
        return `ability:${type}`;
    }
    else {
        return `${namespace}${type}`;
    }
}

function durDmgCont(entity, itemStack, slot, damage) {
    let actualDurability = itemStack.getComponent("minecraft:durability").maxDurability - itemStack.getComponent("minecraft:durability").damage;
    let damageTotalRemove = damage;
    if (actualDurability > damageTotalRemove) {
        itemStack.getComponent("durability").damage = itemStack.getComponent("durability").damage + damageTotalRemove;
        entity.getComponent("minecraft:equippable").setEquipment(slot, itemStack);
    }
    else {
        entity.getComponent("minecraft:equippable").setEquipment(slot, undefined);
        entity.playSound('random.break', entity.location);
    }
    console.warn(`applied ${damage} damage to ${itemStack.typeId} item.`);
}


export { 
    isCreative, 
    getItemType,
    getTagName,
    applyDurabilityDamage
};