import { ItemDurabilityComponent } from "@minecraft/server";

class ItemDurability {
  static damageItem(ItemStack, damage) {
    const itemDurabilityComponent = ItemStack.getComponent(
      ItemDurabilityComponent.componentId
    );

    if (!itemDurabilityComponent) return ItemStack;
    if (itemDurabilityComponent.damage >= itemDurabilityComponent.maxDurability)
      return;
    const remainingDurability =
      itemDurabilityComponent.maxDurability - itemDurabilityComponent.damage;

    itemDurabilityComponent.damage += Math.min(damage, remainingDurability);
    return ItemStack;
  }
}

export default ItemDurability;
